
/**
 * Модуль для  раздела "списков рассылки".
 */

var listemail = (function() {
  return {
    wysiwyg: null, // HTML редактор для   редактирования страниц
    text_suscribe: null,
    email_subscribe: null,
    text_confirm: null,
    text_unsubscribe: null,
    page_subscribe: null,
    /**
     * Инициализирует обработчики для кнопок и элементов раздела.
     */
    init: function() {

      // Вызов модального окна при нажатии на кнопку добавления подписки.
      $('body').on('click', '.section-listemail .add-new-button', function() {
        listemail.openModalWindow('add');			
      });
      
      $('body').on('click', '.section-listemail .row-edit', function() {   
        listemail.openModalWindow('edit',$(this).parents('tr').data('id'));
      });
      
      $('body').on('click', '.section-listemail .row-delete', function() {   
        listemail.deleteListName($(this).parents('tr').data('id'));
      });

      $('body').on('click', '#modal-listemail .dde-modal-save', function() {       
        listemail.saveList($(this).data('id'));
      });
		// переключение табов в модалке
	   $('body').on('click','.tab-title', function () {
        $('#tab1,#tab2,#tab3,#tab4,#tab5').hide();
        $('.tab-title').removeClass('active');
        $(this).addClass('active');
        $($(this).find('a').attr('href')).show();		
        $('.sub'+$(this).find('a').attr('href')).ckeditor();
        return false;
        });

      // Вызов модального окна добавления новых подписчиков.
      $('body').on('click', '.section-listemail .row-subscriber', function() {
        listemail.openModalAddEmail('edit', $(this).parents('tr').data('id'));
      });

      $('body').on('click', '#modal-listemail-addemail .dde-modal-save-email', function() {     
        listemail.saveListEmail($(this).data('id'));
      });
      // переход в раздел email
      $('body').on('click', '.section-listemail .row-email', function() {    
        includeJS(admin.SITE + '/mg-core/script/admin/emailbase.js');
        admin.SECTION = 'emailbase';
        $("#emailbase").parent().addClass('active');
        $("#listemail").parent().removeClass('active');
        admin.show("emailbase.php", "adminpage", "page=0&subscription=" + $(this).parents('tr').data('id')+"&applyFilter=1");  
      });
     // форма для подписки при изменении url 
     $('body').on('change', '#modal-listemail input[name="url"]', function() {     
        var action = $('#modal-listemail input[name="url"]').val();
        var form = '<form name="subscribe" id="subscribe" method="get" action="'+admin.SITE +'/subscribe/'+action+'">\n\
  <input type="hidden" name="addsub" value="1">\n\
  <input type="email" name="email" value="" placeholder="Ваш E-mail" style="width: 150px; margin-bottom: 10px;">\n\
  <input type="submit"\n\
      onclick="if(!$(\'input[name=email]\').val()){alert(\'Поле E-mail необходимо заполнить!\'); return false;}" class="default-btn warning-btn submit-button"\n\
       value="Подписаться" style="width: 150px;">\n\
</form>';
       $('#modal-listemail textarea.subscribe-code').text(form);
       $('#modal-listemail .custom-link').text(action);
       });
       // Обработчик для загрузки файла импорта
      $('body').on('change', '#modal-listemail-addemail input[name="upload"]', function(){
        listemail.uploadCsvToImport();
      });
         // Обработчик для загрузки emailов на сервер, сразу после выбора.
      $('body').on('click', '#modal-listemail-addemail .start-import', function(){               
        $('.block-importer').hide();
        listemail.startImport($('.block-importer .uploading-percent').text());
      });     
       // отмена загрузки csv
       // Обработчик для загрузки файла импорта из CSV
      $('body').on('click', '#modal-listemail-addemail .repeat-upload-csv', function(){
        $('.import-container input[name="upload"]').val('');
        $('.block-upload-сsv').show();
        $('.block-importer').hide();
        $('.repat-upload-file').show();
        $('.cancel-importing').hide();
        $('.message-importing').text('');
      });
      // Отмена ввода подписчиков
      $('body').on('click', '#modal-listemail-addemail .dde-modal-cancel', function(){
        $('#modal-listemail-addemail  .close-reveal-modal').trigger('click');
      });
        // Отмена изменений формы подписки
      $('body').on('click', '#modal-listemail .dde-modal-cancel', function(){
        $('#modal-listemail  .close-reveal-modal').trigger('click');
      });
      // изменение названия подписки
      $('body').on('blur', '#modal-listemail input[name="name"]', function(){  
          if ($('#modal-listemail input[name=url]').val() == '') {
          var text = $('.tite2url').val();
          if (text) {
            text.replace('%', '-');
            text = admin.urlLit(text, 1);
          }
          $('#modal-listemail .custom-link').text(text);
          $('#modal-listemail input[name="url"]').val(text);          
          $('#modal-listemail input[name=url]').trigger('change');
        }
      });
      $('body').on('click', '#modal-listemail .custom-link', function(){
        $('#modal-listemail input[name="url"]').show();
        $(this).hide();
      });
    },

    /**
     * Открывает модальное окно.
     */
    openModalWindow: function(type, id) {

	   try {
        if (CKEDITOR.instances['subscribe1']) {
          CKEDITOR.instances['subscribe1'].destroy();
        }
		 if (CKEDITOR.instances['subscribe2']) {
          CKEDITOR.instances['subscribe2'].destroy();
        }
		 if (CKEDITOR.instances['subscribe3']) {
          CKEDITOR.instances['subscribe3'].destroy();
        }
     if (CKEDITOR.instances['subscribe4']) {
        CKEDITOR.instances['subscribe4'].destroy();
        }
     if (CKEDITOR.instances['subscribe5']) {
        CKEDITOR.instances['subscribe5'].destroy();
        }
      } catch (e) {
      }
	  
      switch (type) {
        case 'edit':
          {
            listemail.clearFields('#modal-listemail');
            $('.remodal-header').text('Редактирование подписки');
            listemail.editeList(id);
            break;
          }
        case 'add':
          {
            listemail.clearFields('#modal-listemail');
            $('.remodal-headern').text('Добавление новой подписки');
            listemail.editeList(0);
            break;
          }
        default:
          {
            listemail.clearFields('#modal-listemail');
            break;
          }
      }
	
     $('textarea[name=text_suscribe]').ckeditor(function () {
        this.setData(listemail.text_suscribe);
      });
       $('textarea[name=email_subscribe]').ckeditor(function () {
        this.setData(listemail.email_subscribe);
      });
      $('textarea[name=text_confirm]').ckeditor(function () {
           this.setData(listemail.text_confirm);
         });
      $('textarea[name=text_unsubscribe]').ckeditor(function () {
           this.setData(listemail.text_unsubscribe);
         });
       $('textarea[name=page_subscribe]').ckeditor(function () {
        this.setData(listemail.page_subscribe);
      });
	 
     $('#modal-listemail').foundation('reveal', 'open');

      $(".toggle-link").on("click", function(){
        var parent = $(this).parents(".toggle-block"),
            active = parent.hasClass("open"),
            text = $(this);

        if(active){
          parent.removeClass("open");
          text.text("Показать");
        }

        else{
          parent.addClass("open");
          text.text("Скрыть");
        }
      });       

    },
     /**
     * Открывает второе модальное окно добавления подписчиков.
     */
    openModalAddEmail: function(type, id) {
    
      listemail.clearFields('#modal-listemail-addemail');
      $('.remodal-header').text('Добавление подписчиков');
      $('#modal-listemail-addemail .dde-modal-save-email').attr('data-id', id); 
      $('#modal-listemail-addemail').foundation('reveal', 'open');

    },

    /**
     *  Проверка заполненности полей, для каждого поля прописывается свое правило.
     */
    checkRulesForm: function() {
      $('.error-field').css('display', 'none');
      $('#modal-listemail input').removeClass('error-input');
      var error = false;

      // все поля обязательно надо заполнить.
      $.each(['name', 'url'], function(index, value) {
        if (!$('#modal-listemail input[name=' + value + ']').val()) {
          $('#modal-listemail input[name=' + value + ']').parent("label").find('.error-field').text('Заполните поле!');
          $('#modal-listemail input[name=' + value + ']').parent("label").find('.error-field').css('display', 'block');
          $('#modal-listemail input[name=' + value + ']').addClass('error-input');
          error = true;
        }
      });


      if (error == true) {
        return false;
      }

      return true;
    },
    /**
     * Сохранение изменений в модальном окне
     * Используется и для сохранения редактированных данных
     * id - идентификатор списка 
     */
    saveList: function(id) {

   
      // Если поля не верно заполнены, то не отправляем запрос на сервер.
      if (!listemail.checkRulesForm()) {
        return false;
      }


      var packed = {
        mguniqueurl: "action/saveList",
        name: $('#modal-listemail input[name=name]').val(),
        url: $('#modal-listemail input[name=url]').val(),	
        text_suscribe: $('#modal-listemail textarea[name=text_suscribe]').val(),
        email_subscribe: $('#modal-listemail textarea[name=email_subscribe]').val(),
        text_confirm: $('#modal-listemail textarea[name=text_confirm]').val(),
        text_unsubscribe: $('#modal-listemail textarea[name=text_unsubscribe]').val(), 
        page_subscribe: $('#modal-listemail textarea[name=page_subscribe]').val(),
        form_subscribe: $('#modal-listemail textarea.subscribe-code').val(),
      }
      if(id){
        packed.id = id;
      }
	

      // отправка данных на сервер для сохранения
      admin.ajaxRequest(packed,
        function(response) {       
          admin.indication(response.status, response.msg);
          admin.refreshPanel();
          // Закрываем окно    
          $('#modal-listemail').foundation('reveal', 'close');
        }
      );
    },

    saveListEmail: function(id) {

   
      var packed = {
        mguniqueurl: "action/saveEmailsToSubscriberListName",
        emails: $('#modal-listemail-addemail textarea[name=list_email]').val(),
        id: id,
      }

      // отправка данных на сервер для сохранения
      admin.ajaxRequest(packed,
        function(response) {       
          admin.indication(response.status, response.msg);
          admin.refreshPanel();
          // Закрываем окно    
          $('#modal-listemail-addemail').foundation('reveal', 'close');
        }
      );
    },

    /**
     * Получает данные с сервера и заполняет ими поля в окне.
     */
    editeList: function(id) {
      admin.ajaxRequest({
        mguniqueurl: "action/getList",
        id: id
      },
      listemail.fillFileds()
        );
    },

    /**
     * Удаляет список из БД сайта и таблицы в текущем разделе
     */
    deleteListName: function(id) {
      if (confirm('Удалить?')) {
        admin.ajaxRequest({
          mguniqueurl: "action/deleteListName",
          id: id
        },
        function(response) {
          admin.indication(response.status, response.msg);
          admin.refreshPanel();
          // Закрываем окно    
          $('#modal-listemail').foundation('reveal', 'close');
        }
      );
      }
    },
    /**
     * Заполняет поля модального окна данными
     */
    fillFileds: function() {
      return (function(response) {
        $('.error-field').css('display', 'none');
        $('#modal-listemail input[name=name]').val(response.data.name);
        $('#modal-listemail input[name=url]').val(response.data.url);
        $('#modal-listemail .custom-link').text(response.data.url);
        $('#modal-listemail textarea.subscribe-code').text(response.data.	form_subscribe);
        /*$('#modal-listemail textarea[name=text_suscribe]').val(response.data.text_suscribe);
        $('#modal-listemail textarea[name=text_confirm]').val(response.data.text_confirm);
        $('#modal-listemail textarea[name=text_unsubscribe]').val(response.data.text_unsubscribe);
		*/
		listemail.text_suscribe = response.data.text_suscribe;
    listemail.email_subscribe = response.data.email_subscribe;
		listemail.text_confirm = response.data.text_confirm;
		listemail.text_unsubscribe = response.data.text_unsubscribe;
    listemail.page_subscribe = response.data.page_subscribe;
		 
        $('#modal-listemail .dde-modal-save').attr('data-id', response.data.id);  
      })
    },
    /**
     * Чистит все поля модального окна
     */
    clearFields: function(idModal) {
     
      if(idModal == '#modal-listemail'){
        $('.error-field').css('display', 'none');
        $('#modal-listemail input[name=name]').val('');
        $('#modal-listemail input[name=url]').val('');
        $('#modal-listemail .custom-link').text('');
        $('#modal-listemail textarea[name=text_suscribe]').val('');
        $('#modal-listemail textarea[name=email_subscribe]').val('');
        $('#modal-listemail textarea[name=text_confirm]').val('');
        $('#modal-listemail textarea[name=text_unsubscribe]').val('');
        $('#modal-listemail textarea[name=page_subscribe]').val('');
        $('#modal-listemail .dde-modal-save').attr('data-id', ''); 
        $('#modal-listemail textarea.subscribe-code').text('');
        $('#modal-listemail input[name=url]').hide();
		listemail.text_suscribe = '';
    listemail.email_subscribe = '';
		listemail.text_confirm = '';
		listemail.text_unsubscribe = '';
    listemail.page_subscribe = '';
	  }

      if(idModal == '#modal-listemail-addemail'){      
        $('.error-field').css('display', 'none');
        $('#modal-listemail-addemail textarea[name=list_email]').val(''); 
      }   
    },
    /**
     * Загружает CSV файл на сервер для последующего импорта
     */
    uploadCsvToImport:function() {
      // отправка файла CSV на сервер
      $('.message-importing').text('Идет передача файла на сервер. Подождите, пожалуйста...');
      $('.upload-csv-form').ajaxForm({
        type:"POST",
        url: "ajax",
        data: {
          mguniqueurl:"action/uploadCsvToImport"
        },
        cache: false,
        dataType: 'json',
        error: function() {alert("Загружаемый вами файл превысил максимальный объем и не может быть передан на сервер из-за ограничения в настройках файла php.ini\n\n{Внимание! Поддерживается загрузка zip архива с CSV файлом}");},
        success: function(response){
          admin.indication(response.status, response.msg);
          if(response.status=='succes'){
            $('.block-upload-сsv').hide();
            $('.block-importer').show();
            $('.message-importing').text('Файл готов к импорту');
          }else{
            $('.message-importing').text('');
            $('.import-container input[name="upload"]').val('');
          }
        },
      }).submit();
    },
      /**
     * Контролирует процесс импорта, выводит индикатор в процентах обработки каталога.
     */
    startImport:function(rowId, percent) {
       if(!rowId){
        if(!$('.loading-line').length) {
          $('.process').append('<div class="loading-line"></div>');
        }        
        rowId = 0;
      }      
      if(!percent){
        percent = 0;
      }     
      $('.message-importing').html('Идет процесс импорта. Загружено:'+percent+'%<div class="progress-bar"><div class="progress-bar-inner" style="width:'+percent+'%;"></div></div>');
      var listnameId = $('#modal-listemail-addemail .dde-modal-save-email').data('id'); 
      // отправка файла CSV на сервер
      admin.ajaxRequest({
        mguniqueurl:"action/startImportEmail",
        rowId:rowId,
        listnameId:  listnameId
      },
      function(response){
        if(response.status=='error'){
          admin.indication(response.status, response.msg);
          $('.block-importer').hide();
          $('.block-upload-сsv').show();
          $('.loading-line').remove();
           $('.import-container input[name="upload"]').val('');
           $('.message-importing').text(response.msg);
          return false;
        }
        if(response.data.percent<100){
            listemail.startImport(response.data.rowId,response.data.percent);
        } else {
           admin.indication(response.status, response.msg);
           $('#modal-listemail-addemail  .close-reveal-modal').trigger('click');
           $('.block-importer').hide();
           $('.block-upload-сsv').show();
           $('.loading-line').remove();
           $('.message-importing').text('');           
        }
      });
    },
  }
})();

// инициализациямодуля при подключении
listemail.init();

